<?php

namespace Drupal\viz_builder_ui\PathProcessor;

use Drupal\Core\PathProcessor\InboundPathProcessorInterface;
use Symfony\Component\HttpFoundation\Request;

/**
 * Defines a path processor to rewrite file URLs.
 *
 * As the route system does not allow arbitrary amount of parameters convert
 * the file path to a query parameter on the request.
 */
class PathProcessorBuilderUI implements InboundPathProcessorInterface {

  /**
   * {@inheritdoc}
   */
  public function processInbound($path, Request $request) {
    if (str_starts_with($path, '/builder/') && !$request->query->has('file')) {
      $file_path = preg_replace('|^\/builder\/|', '', $path);
      $request->query->set('file', $file_path);
      return '/builder';
    }
    return $path;
  }

}
