<?php

namespace Drupal\viz_builder\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\FormatterBase;

/**
 * Plugin implementation of the 'twig_formatter' formatter.
 *
 * @FieldFormatter(
 *   id = "twig_formatter",
 *   label = @Translation("Twig formatter"),
 *   field_types = {
 *     "text",
 *     "text_long",
 *     "string_long",
 *   }
 * )
 */
class TwigFormatter extends FormatterBase {

  public function settingsSummary() {
    $summary = [];
    $summary[] = t('Twig formatter');
    return $summary;
  }

  public function viewElements(FieldItemListInterface $items, $langcode) {
    $moduleHandler = \Drupal::moduleHandler();
    $elements = [];
    $context = [];
    $context = $moduleHandler->invokeAll('twig_formatter_context', [$context, $items]);

    if (!$items->isEmpty()) {
      $elements[0] = [
        '#type' => 'inline_template',
        '#template' => $items->getValue()[0]['value'],
        '#context' => $context,
      ];
    }

    return $elements;
  }

}
